added RCSID
[strongswan.git] / src / _updown / _updown.in
1 #! /bin/sh
2 # iproute2 version, default updown script
3 #
4 # Copyright (C) 2003-2004 Nigel Meteringham
5 # Copyright (C) 2003-2004 Tuomo Soini
6 # Copyright (C) 2002-2004 Michael Richardson
7 # Copyright (C) 2005-2007 Andreas Steffen <andreas.steffen@strongswan.org>
8
9 # This program is free software; you can redistribute it and/or modify it
10 # under the terms of the GNU General Public License as published by the
11 # Free Software Foundation; either version 2 of the License, or (at your
12 # option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
13
14 # This program is distributed in the hope that it will be useful, but
15 # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
16 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
17 # for more details.
18 #
19 # RCSID $Id$
20
21 # CAUTION:  Installing a new version of strongSwan will install a new
22 # copy of this script, wiping out any custom changes you make.  If
23 # you need changes, make a copy of this under another name, and customize
24 # that, and use the (left/right)updown parameters in ipsec.conf to make
25 # strongSwan use yours instead of this default one.
26
27 # things that this script gets (from ipsec_pluto(8) man page)
28 #
29 #      PLUTO_VERSION
30 #              indicates  what  version of this interface is being
31 #              used.  This document describes version  1.1.   This
32 #              is upwardly compatible with version 1.0.
33 #
34 #       PLUTO_VERB
35 #              specifies the name of the operation to be performed
36 #              (prepare-host, prepare-client, up-host, up-client,
37 #              down-host, or down-client).  If the address family
38 #              for security gateway to security gateway communica¬≠
39 #              tions is IPv6, then a suffix of -v6 is added to the
40 #              verb.
41 #
42 #       PLUTO_CONNECTION
43 #              is the name of the  connection  for  which  we  are
44 #              routing.
45 #
46 #       PLUTO_NEXT_HOP
47 #              is the next hop to which packets bound for the peer
48 #              must be sent.
49 #
50 #       PLUTO_INTERFACE
51 #              is the name of the ipsec interface to be used.
52 #
53 #       PLUTO_REQID
54 #              is the requid of the ESP policy
55 #
56 #       PLUTO_ME
57 #              is the IP address of our host.
58 #
59 #       PLUTO_MY_ID
60 #              is the ID of our host.
61 #
62 #       PLUTO_MY_CLIENT
63 #              is the IP address / count of our client subnet.  If
64 #              the  client  is  just  the  host,  this will be the
65 #              host's own IP address / max (where max  is  32  for
66 #              IPv4 and 128 for IPv6).
67 #
68 #       PLUTO_MY_CLIENT_NET
69 #              is the IP address of our client net.  If the client
70 #              is just the host, this will be the  host's  own  IP
71 #              address.
72 #
73 #       PLUTO_MY_CLIENT_MASK
74 #              is  the  mask for our client net.  If the client is
75 #              just the host, this will be 255.255.255.255.
76 #
77 #       PLUTO_MY_SOURCEIP
78 #              if non-empty, then the source address for the route will be
79 #              set to this IP address.
80 #
81 #       PLUTO_MY_PROTOCOL
82 #              is the IP protocol that will be transported.
83 #
84 #       PLUTO_MY_PORT
85 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
86 #              restricted on our side.
87 #
88 #       PLUTO_PEER
89 #              is the IP address of our peer.
90 #
91 #       PLUTO_PEER_ID
92 #              is the ID of our peer.
93 #
94 #       PLUTO_PEER_CA
95 #              is the CA which issued the cert of our peer.
96 #
97 #       PLUTO_PEER_CLIENT
98 #              is the IP address / count of the peer's client sub¬≠
99 #              net.   If the client is just the peer, this will be
100 #              the peer's own IP address / max (where  max  is  32
101 #              for IPv4 and 128 for IPv6).
102 #
103 #       PLUTO_PEER_CLIENT_NET
104 #              is the IP address of the peer's client net.  If the
105 #              client is just the peer, this will  be  the  peer's
106 #              own IP address.
107 #
108 #       PLUTO_PEER_CLIENT_MASK
109 #              is  the  mask  for  the  peer's client net.  If the
110 #              client   is   just   the   peer,   this   will   be
111 #              255.255.255.255.
112 #
113 #       PLUTO_PEER_PROTOCOL
114 #              is the IP protocol that will be transported.
115 #
116 #       PLUTO_PEER_PORT
117 #              is  the  UDP/TCP  port  to  which  the IPsec SA  is
118 #              restricted on the peer side.
119 #
120
121 # uncomment to log VPN connections
122 VPN_LOGGING=1
123 #
124 # tag put in front of each log entry:
125 TAG=vpn
126 #
127 # syslog facility and priority used:
128 FAC_PRIO=local0.notice
129 #
130 # to create a special vpn logging file, put the following line into
131 # the syslog configuration file /etc/syslog.conf:
132 #
133 # local0.notice                   -/var/log/vpn
134
135 # in order to use source IP routing the Linux kernel options
136 # CONFIG_IP_ADVANCED_ROUTER and CONFIG_IP_MULTIPLE_TABLES
137 # must be enabled
138 #
139 # special routing table for sourceip routes
140 SOURCEIP_ROUTING_TABLE=@IPSEC_ROUTING_TABLE@
141 #
142 # priority of the sourceip routing table
143 SOURCEIP_ROUTING_TABLE_PRIO=@IPSEC_ROUTING_TABLE_PRIO@
144
145 # check interface version
146 case "$PLUTO_VERSION" in
147 1.[0|1])        # Older Pluto?!?  Play it safe, script may be using new features.
148         echo "$0: obsolete interface version \`$PLUTO_VERSION'," >&2
149         echo "$0:       called by obsolete Pluto?" >&2
150         exit 2
151         ;;
152 1.*)    ;;
153 *)      echo "$0: unknown interface version \`$PLUTO_VERSION'" >&2
154         exit 2
155         ;;
156 esac
157
158 # check parameter(s)
159 case "$1:$*" in
160 ':')                    # no parameters
161         ;;
162 iptables:iptables)      # due to (left/right)firewall; for default script only
163         ;;
164 custom:*)               # custom parameters (see above CAUTION comment)
165         ;;
166 *)      echo "$0: unknown parameters \`$*'" >&2
167         exit 2
168         ;;
169 esac
170
171 # utility functions for route manipulation
172 # Meddling with this stuff should not be necessary and requires great care.
173 uproute() {
174         doroute add
175         ip route flush cache
176 }
177 downroute() {
178         doroute delete
179         ip route flush cache
180 }
181
182 addsource() {
183         st=0
184         if ! ip -o route get ${PLUTO_MY_SOURCEIP%/*} | grep -q ^local
185         then
186             it="ip addr add ${PLUTO_MY_SOURCEIP%/*}/32 dev $PLUTO_INTERFACE"
187             oops="`eval $it 2>&1`"
188             st=$?
189             if test " $oops" = " " -a " $st" != " 0"
190             then
191                 oops="silent error, exit status $st"
192             fi
193             if test " $oops" != " " -o " $st" != " 0"
194             then
195                 echo "$0: addsource \`$it' failed ($oops)" >&2
196             fi
197         fi
198         return $st
199 }
200
201 doroute() {
202         st=0
203
204         if [ -z "$PLUTO_MY_SOURCEIP" ]
205         then
206             if [ -f /etc/sysconfig/defaultsource ]
207             then
208                 . /etc/sysconfig/defaultsource
209             fi
210
211             if [ -f /etc/conf.d/defaultsource ]
212             then
213                 . /etc/conf.d/defaultsource
214             fi
215
216             if [ -n "$DEFAULTSOURCE" ]
217             then
218                 PLUTO_MY_SOURCEIP=$DEFAULTSOURCE
219             fi
220         fi
221
222         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
223         then
224             # leave because no route entry is required
225             return $st
226         fi
227
228         parms1="$PLUTO_PEER_CLIENT"
229
230         if [ -n "$PLUTO_NEXT_HOP" ]
231         then
232             parms2="via $PLUTO_NEXT_HOP"
233         else
234             parms2="via $PLUTO_PEER"
235         fi      
236         parms2="$parms2 dev $PLUTO_INTERFACE"
237
238         parms3=
239         if [ -n "$PLUTO_MY_SOURCEIP" ]
240         then
241             if test "$1" = "add"
242             then
243                 addsource
244                 if ! ip rule list | grep -q "lookup $SOURCEIP_ROUTING_TABLE"
245                 then
246                     ip rule add pref $SOURCEIP_ROUTING_TABLE_PRIO table $SOURCEIP_ROUTING_TABLE
247                 fi
248             fi
249             parms3="$parms3 src ${PLUTO_MY_SOURCEIP%/*} table $SOURCEIP_ROUTING_TABLE"
250         fi
251
252         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
253         "0.0.0.0/0.0.0.0")
254                 # opportunistic encryption work around
255                 # need to provide route that eclipses default, without 
256                 # replacing it.
257                 it="ip route $1 0.0.0.0/1 $parms2 $parms3 &&
258                         ip route $1 128.0.0.0/1 $parms2 $parms3"
259                 ;;
260         *)      it="ip route $1 $parms1 $parms2 $parms3"
261                 ;;
262         esac
263         oops="`eval $it 2>&1`"
264         st=$?
265         if test " $oops" = " " -a " $st" != " 0"
266         then
267             oops="silent error, exit status $st"
268         fi
269         if test " $oops" != " " -o " $st" != " 0"
270         then
271             echo "$0: doroute \`$it' failed ($oops)" >&2
272         fi
273         return $st
274 }
275  
276 # in the presence of KLIPS and ipsecN interfaces do not use IPSEC_POLICY 
277 if [ `echo "$PLUTO_INTERFACE" | grep "ipsec"` ]
278 then
279         KLIPS=1
280         IPSEC_POLICY_IN=""
281         IPSEC_POLICY_OUT=""
282 else
283         KLIPS=
284         IPSEC_POLICY="-m policy --pol ipsec --proto esp --reqid $PLUTO_REQID"
285         IPSEC_POLICY_IN="$IPSEC_POLICY --dir in"
286         IPSEC_POLICY_OUT="$IPSEC_POLICY --dir out"
287 fi
288
289 # are there port numbers?
290 if [ "$PLUTO_MY_PORT" != 0 ]
291 then
292         S_MY_PORT="--sport $PLUTO_MY_PORT"
293         D_MY_PORT="--dport $PLUTO_MY_PORT"
294 fi
295 if [ "$PLUTO_PEER_PORT" != 0 ]
296 then
297         S_PEER_PORT="--sport $PLUTO_PEER_PORT"
298         D_PEER_PORT="--dport $PLUTO_PEER_PORT"
299 fi
300
301 # the big choice
302 case "$PLUTO_VERB:$1" in
303 prepare-host:*|prepare-client:*)
304         if [ -z "$KLIPS" -a -z "$PLUTO_MY_SOURCEIP" ]
305         then
306             # exit because no route will be added,
307             # so that existing routes can stay
308             exit 0
309         fi
310
311         # delete possibly-existing route (preliminary to adding a route)
312         case "$PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK" in
313         "0.0.0.0/0.0.0.0")
314                 # need to provide route that eclipses default, without 
315                 # replacing it.
316                 parms1="0.0.0.0/1"
317                 parms2="128.0.0.0/1"
318                 it="ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1"
319                 oops="`ip route delete $parms1 2>&1 ; ip route delete $parms2 2>&1`"
320                 ;;
321         *)
322                 parms="$PLUTO_PEER_CLIENT"
323                 it="ip route delete $parms 2>&1"
324                 oops="`ip route delete $parms 2>&1`"
325                 ;;
326         esac
327         status="$?"
328         if test " $oops" = " " -a " $status" != " 0"
329         then
330                 oops="silent error, exit status $status"
331         fi
332         case "$oops" in
333         *'RTNETLINK answers: No such process'*) 
334                 # This is what route (currently -- not documented!) gives
335                 # for "could not find such a route".
336                 oops=
337                 status=0
338                 ;;
339         esac
340         if test " $oops" != " " -o " $status" != " 0"
341         then
342                 echo "$0: \`$it' failed ($oops)" >&2
343         fi
344         exit $status
345         ;;
346 route-host:*|route-client:*)
347         # connection to me or my client subnet being routed
348         uproute
349         ;;
350 unroute-host:*|unroute-client:*)
351         # connection to me or my client subnet being unrouted
352         downroute
353         ;;
354 up-host:)
355         # connection to me coming up
356         # If you are doing a custom version, firewall commands go here.
357         ;;
358 down-host:)
359         # connection to me going down
360         # If you are doing a custom version, firewall commands go here.
361         ;;
362 up-client:)
363         # connection to my client subnet coming up
364         # If you are doing a custom version, firewall commands go here.
365         ;;
366 down-client:)
367         # connection to my client subnet going down
368         # If you are doing a custom version, firewall commands go here.
369         ;;
370 up-host:iptables)
371         # connection to me, with (left/right)firewall=yes, coming up
372         # This is used only by the default updown script, not by your custom
373         # ones, so do not mess with it; see CAUTION comment up at top.
374         iptables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
375             -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
376             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
377         iptables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
378             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
379             -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT -j ACCEPT
380         #
381         # log IPsec host connection setup
382         if [ $VPN_LOGGING ]
383         then
384           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
385           then
386             logger -t $TAG -p $FAC_PRIO \
387               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME"
388           else
389             logger -t $TAG -p $FAC_PRIO \
390               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
391           fi
392         fi      
393         ;;
394 down-host:iptables)
395         # connection to me, with (left/right)firewall=yes, going down
396         # This is used only by the default updown script, not by your custom
397         # ones, so do not mess with it; see CAUTION comment up at top.
398         iptables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
399             -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
400             -d $PLUTO_ME $D_MY_PORT $IPSEC_POLICY_IN -j ACCEPT
401         iptables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
402             -s $PLUTO_ME $S_MY_PORT $IPSEC_POLICY_OUT \
403             -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT -j ACCEPT
404         #
405         # log IPsec host connection teardown
406         if [ $VPN_LOGGING ]
407         then
408           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
409           then
410             logger -t $TAG -p $FAC_PRIO -- \
411               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME"
412           else
413             logger -t $TAG -p $FAC_PRIO -- \
414             "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME"
415           fi
416         fi
417         ;;
418 up-client:iptables)
419         # connection to client subnet, with (left/right)firewall=yes, coming up
420         # This is used only by the default updown script, not by your custom
421         # ones, so do not mess with it; see CAUTION comment up at top.
422         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ]
423         then
424           iptables -I FORWARD 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
425               -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $S_MY_PORT \
426               -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT \
427                  $IPSEC_POLICY_OUT -j ACCEPT
428           iptables -I FORWARD 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
429               -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
430               -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $D_MY_PORT \
431                  $IPSEC_POLICY_IN -j ACCEPT
432         fi
433         #
434         # a virtual IP requires an INPUT and OUTPUT rule on the host
435         # or sometimes host access via the internal IP is needed
436         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
437         then
438           iptables -I INPUT 1 -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
439               -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
440               -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $D_MY_PORT \
441                  $IPSEC_POLICY_IN -j ACCEPT
442           iptables -I OUTPUT 1 -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
443               -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $S_MY_PORT \
444               -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT \
445                  $IPSEC_POLICY_OUT -j ACCEPT
446         fi
447         #
448         # log IPsec client connection setup
449         if [ $VPN_LOGGING ]
450         then
451           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
452           then
453             logger -t $TAG -p $FAC_PRIO \
454               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
455           else
456             logger -t $TAG -p $FAC_PRIO \
457               "+ `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
458           fi
459         fi
460         ;;
461 down-client:iptables)
462         # connection to client subnet, with (left/right)firewall=yes, going down
463         # This is used only by the default updown script, not by your custom
464         # ones, so do not mess with it; see CAUTION comment up at top.
465         if [ "$PLUTO_PEER_CLIENT" != "$PLUTO_MY_SOURCEIP/32" ]
466         then
467           iptables -D FORWARD -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
468               -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $S_MY_PORT \
469               -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT \
470                  $IPSEC_POLICY_OUT -j ACCEPT
471           iptables -D FORWARD -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
472               -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
473               -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $D_MY_PORT \
474                  $IPSEC_POLICY_IN -j ACCEPT
475         fi
476         #
477         # a virtual IP requires an INPUT and OUTPUT rule on the host
478         # or sometimes host access via the internal IP is needed
479         if [ -n "$PLUTO_MY_SOURCEIP" -o -n "$PLUTO_HOST_ACCESS" ]
480         then
481           iptables -D INPUT -i $PLUTO_INTERFACE -p $PLUTO_MY_PROTOCOL \
482               -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $S_PEER_PORT \
483               -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $D_MY_PORT \
484                  $IPSEC_POLICY_IN -j ACCEPT
485           iptables -D OUTPUT -o $PLUTO_INTERFACE -p $PLUTO_PEER_PROTOCOL \
486               -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK $S_MY_PORT \
487               -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK $D_PEER_PORT \
488                  $IPSEC_POLICY_OUT -j ACCEPT
489         fi
490         #
491         # log IPsec client connection teardown
492         if [ $VPN_LOGGING ]
493         then
494           if [ "$PLUTO_PEER_CLIENT" == "$PLUTO_PEER/32" ]
495           then
496             logger -t $TAG -p $FAC_PRIO -- \
497               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
498           else
499             logger -t $TAG -p $FAC_PRIO -- \
500               "- `echo -e $PLUTO_PEER_ID` $PLUTO_PEER_CLIENT == $PLUTO_PEER -- $PLUTO_ME == $PLUTO_MY_CLIENT"
501           fi
502         fi
503         ;;
504 #
505 # IPv6
506 #
507 prepare-host-v6:*|prepare-client-v6:*)
508         ;;
509 route-host-v6:*|route-client-v6:*)
510         # connection to me or my client subnet being routed
511         #uproute_v6
512         ;;
513 unroute-host-v6:*|unroute-client-v6:*)
514         # connection to me or my client subnet being unrouted
515         #downroute_v6
516         ;;
517 up-host-v6:*)
518         # connection to me coming up
519         # If you are doing a custom version, firewall commands go here.
520         ;;
521 down-host-v6:*)
522         # connection to me going down
523         # If you are doing a custom version, firewall commands go here.
524         ;;
525 up-client-v6:)
526         # connection to my client subnet coming up
527         # If you are doing a custom version, firewall commands go here.
528         ;;
529 down-client-v6:)
530         # connection to my client subnet going down
531         # If you are doing a custom version, firewall commands go here.
532         ;;
533 *)      echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
534         exit 1
535         ;;
536 esac